.\" $XFree86: xc/programs/Xserver/hw/xfree86/drivers/nv/nv.man,v 1.17 2003/02/11 00:00:18 mvojkovi Exp $ 
.\" shorthand for double quote that works everywhere.
.ds q \N'34'
.TH NV __drivermansuffix__ __vendorversion__
.SH NAME
nv \- NVIDIA video driver
.SH SYNOPSIS
.nf
.B "Section \*qDevice\*q"
.BI "  Identifier \*q"  devname \*q
.B  "  Driver \*qnv\*q"
\ \ ...
.B EndSection
.fi
.SH DESCRIPTION
.B nv 
is an XFree86 driver for NVIDIA video cards.  The driver supports full 2D 
acceleration and provides support for the following framebuffer depths:
8, 15, 16 (except Riva128) and 24.  All
visual types are supported for depth 8, TrueColor and DirectColor
visuals are supported for the other depths with the exception of
the Riva128 which only supports TrueColor in the higher depths. 

.SH SUPPORTED HARDWARE
The
.B nv
driver supports PCI and AGP video cards based on the following NVIDIA chips:
.TP 22
.B RIVA 128
NV3
.TP 22
.B RIVA TNT
NV4
.TP 22
.B RIVA TNT2
NV5
.TP 22
.B GeForce 256, QUADRO 
NV10
.TP 22
.B GeForce2, QUADRO2
NV11 & NV15  
.TP 22
.B GeForce3, QUADRO DCC
NV20
.TP 22
.B nForce, nForce2
NV1A, NV1F
.TP 22
.B GeForce4, QUADRO4
NV17, NV18, NV25, NV28
.TP 22
.B GeForce FX, QUADRO FX
NV30
.SH CONFIGURATION DETAILS
Please refer to XF86Config(__filemansuffix__) for general configuration
details.  This section only covers configuration details specific to this
driver.
.PP
The driver auto-detects the chipset type and the amount of video memory
present for all chips.
.PP
The following driver
.B Options
are supported:
.TP
.BI "Option \*qHWCursor\*q \*q" boolean \*q
Enable or disable the HW cursor.  Default: on.
.TP
.BI "Option \*qNoAccel\*q \*q" boolean \*q
Disable or enable acceleration.  Default: acceleration is enabled.
.TP
.BI "Option \*qUseFBDev\*q \*q" boolean \*q
Enable or disable use of on OS-specific fb interface (and is not supported
on all OSs).  See fbdevhw(__drivermansuffix__) for further information.
Default: off.
.TP
.BI "Option \*qCrtcNumber\*q \*q" integer \*q
nForce2, Quadro4, GeForce4 and NV30 may have two video outputs.  
The driver attempts to autodetect
which one the monitor is connected to.  In the case that autodetection picks
the wrong one, this option may be used to force usage of a particular output. 
The options are "0" or "1".
Default: autodetected.
.TP
.BI "Option \*qFlatPanel\*q \*q" boolean \*q
The driver usually cannot autodetect the presence of a flat panel so
this option should be set when used with a flat panel.  With this driver
a flat panel will only work if it was POSTed by the BIOS, that is, the
machine must have booted to the panel.
Default: off.
.TP
.BI "Option \*qFPDither\*q \*q" boolean \*q
Most digital flat panels have only 6 bits per component color resolution.
This option tells the driver to dither from 8 bits per component to 6 before
the flat panel truncates it. This is only suported in depth 24 on NV11, 
nForce2, GeForce4, Quadro4 and NV30.
Default: off.
.TP
.BI "Option \*qRotate\*q \*qCW\*q"
.TP
.BI "Option \*qRotate\*q \*qCCW\*q"
Rotate the display clockwise or counterclockwise.  This mode is unaccelerated.
Default: no rotation.

Note: Option Rotate does not work unless the Resize and Rotate extension has
been turned off.
.TP
.BI "Option \*qShadowFB\*q \*q" boolean \*q
Enable or disable use of the shadow framebuffer layer.  Default: off.
.SH "SEE ALSO"
XFree86(1), XF86Config(__filemansuffix__), xf86config(1), Xserver(1), X(__miscmansuffix__)
.SH AUTHORS
Authors include: David McKay, Jarno Paananen, Chas Inman, Dave Schmenk, 
Mark Vojkovich
